SET LANGUAGE russian
SET IMPLICIT_TRANSACTIONS OFF
SET ANSI_NULLS ON
SET ANSI_PADDING ON
SET ANSI_WARNINGS ON
SET CONCAT_NULL_YIELDS_NULL ON
SET NUMERIC_ROUNDABORT OFF
SET NOCOUNT OFF
SET LOCK_TIMEOUT -1
SET XACT_ABORT ON
SET ARITHABORT ON
SET CURSOR_CLOSE_ON_COMMIT OFF
SET DATEFIRST 1
SET DATEFORMAT DMY
SET QUOTED_IDENTIFIER ON
GO

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'dbo.[VX_UPGRADE_S_RELEASE]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE dbo.[VX_UPGRADE_S_RELEASE]

GO

/*
  (Keysystems), 2005
*/

CREATE  PROCEDURE VX_UPGRADE_S_RELEASE
AS

SELECT SO.LINK as Project, SR.Release, SR.Fix
INTO #tmpRelease
FROM S_RELEASE_U SR, S_OBJECTS_U SOU, S_OBJECTS SO
WHERE Project = SOU.LINK AND RTRIM(LTRIM(SO.CODE))=RTRIM(LTRIM(SOU.CODE))
	and not exists(Select Release From S_Release Where Release = SR.Release and Project = SO.LINK AND Fix = SR.Fix)

BEGIN TRAN
	INSERT INTO S_RELEASE(Project, Release, Fix)
	SELECT Project, Release, Fix
	FROM #tmpRelease
	
	
	Select SFU.Name, SR.ID as Release, SFU.Path, SFU.CreateDate, SFU.FileSize, SFU.ID as oldID
	INTO #tmpFiles
	From S_FILES_U SFU INNER JOIN S_RELEASE_U SUR ON SFU.Release = SUR.ID
		INNER JOIN S_RELEASE SR ON SUR.Release = SR.Release AND SUR.Fix = SR.Fix
		INNER JOIN #tmpRelease TR ON SR.Release = TR.Release
			AND SR.Project = TR.Project AND SR.Fix = TR.Fix
	
	
	DELETE FROM S_FILES
	FROM #tmpFiles T WHERE T.NAME = S_FILES.NAME
	
	
	INSERT INTO S_FILES(Name, Release, Path, CreateDate, FileSize)
	SELECT Name, Release, Path, CreateDate, FileSize
	From #tmpFiles
	
	
	INSERT INTO S_FILEPARTS(File_ID, ORDERS, BODY)
	Select SF.ID, SPU.Orders, convert(varchar(8000), SPU.Body)
	From S_FILES SF, S_FILEPARTS_U SPU, #tmpFiles TF
	Where SF.Release = TF.Release
		AND SF.Name = TF.Name
		AND SPU.File_ID = TF.oldID

	/* HISTORY */
	DELETE FROM dbo.HISTORY
	
	INSERT INTO dbo.HISTORY(LINK_UP, TASK_CODE, INFO)
	SELECT NEW.ID, HU.TASK_CODE, HU.INFO FROM dbo.HISTORY_U HU INNER JOIN dbo.S_RELEASE_U OLD ON HU.LINK_UP = OLD.ID
	INNER JOIN dbo.S_RELEASE NEW ON OLD.RELEASE = NEW.RELEASE AND OLD.FIX = NEW.FIX
	--- HISTORY


	/* FAQ */
	DELETE FROM dbo.FAQ
	
	INSERT INTO dbo.FAQ (TASK,GRP,ORDERS,QUEST,ANSWER)
	SELECT TASK,GRP,ORDERS,QUEST,ANSWER FROM dbo.FAQ_U
	-- FAQ

	IF EXISTS(select * from s_files F
		where F.Filesize <> (select sum(datalength(body)) from s_fileparts where file_id = F.id))
	BEGIN 
		ROLLBACK
		raiserror('     !   !',11,1)
		RETURN
	END
WHILE @@TRANCOUNT > 0
	COMMIT TRAN

Drop Table #tmpFiles
Drop Table #tmpRelease




GO


GRANT EXECUTE ON dbo.[VX_UPGRADE_S_RELEASE] TO PUBLIC

GO

--  
exec VX_UPGRADE_S_RELEASE
GO

WHILE @@TRANCOUNT > 0
	raiserror('@@TRANCOUNT>0!!!',11,1)
GO
